#! /bin/bash

# Environment setup
. ./gridcl.env

# Command echo on
set -x 

# Copy make.inc - for the makefile (compiler, MPI, OpenCL, ...)
rm make.inc
ln -s  make.GridCL make.inc

#
#   Build
#
# Intel compiler and MPI
make clean
make

cp input_sedov_noio_5000x5000.nml hInput.nml

#
#   Run on 16 cores with 2 MPI process and 8 OpenMP threads 
# 
export OMP_NUM_THREADS=8
mpiexec -np 2 ./hydro hInput.nml

 